#include "taskFlyport.h"
#include "sd_manager.h"
//http://wiki.openpicus.com/index.php/Lib_sd_card_fat_file_system

#define  SER_DEBUG

#define   LED_G_ON         IOPut(p31 , 1)
#define   LED_G_OFF        IOPut(p31 , 0)
#define   LED_G_TOGGLE     IOPut(p31 , IOGet(p31) ^ 0x01)

#define   LED_R_ON         IOPut(p32 , 1)
#define   LED_R_OFF        IOPut(p32 , 0)
#define   LED_R_TOGGLE     IOPut(p32 , IOGet(p32) ^ 0x01)

#define GROVE_NEST

#define FILE_LOG            "log.txt"

char                debug[255];
BYTE                sdToInit    = 1;

void FlyportTask() {
    int i;
	vTaskDelay(25);
	UARTWrite(1,"Flyport Wi-fi PRO SD\r\n");
	
    for(i = 0; i < 9; i++) ADCDetach(i);
	IOInit(p31, out);  //LED VERDE 
	IOInit(p32, out);  //LED ROSSO
	IOInit(p20, inup); // SD-CS line
	
	while(1) {
		LED_G_TOGGLE;
		vTaskDelay(25);
		
		if (!IOGet(p20)) { //SD fisicamente presente
          if (sdToInit){  //SD da inizializzare
		    #ifdef SER_DEBUG
			  UARTWrite(1, "Inizializzazione SD Card\n");
            #endif
			/*
			int pin_sck - pin used as SPI SCLK signal
			int pin_si - pin used as SPI MISO signal
			int pin_so - pin used as SPI MOSI signal
			int pin_cs - pin used as SD Chip Select signal
			int pin_cd - pin used as SD Card Detect signal
			BYTE _nTimeout - timeout of operation (expressed in about 0.1 sec scale, 255 to wait forever) 
			*/
			
			//SDInit(int pin_sck, int pin_si, int pin_so, int pin_cs, int pin_cd, BYTE timeout)
		  //if(SDInit(p18, p7, p17, p9, p19, 15)){
			if(SDInit(p7, p3, p1, p17, p20, 15)){
              #ifdef SER_DEBUG
			    sprintf(debug, "SD Card inizializzata\r\nSpazio free SD %lu\r\n", SDFreeSpace());
			    UARTWrite(1,debug);
              #endif
			  sdToInit=0;
			  
			  
			if(!SDFileCheck(FILE_LOG)) { //Creo il file se non esiste
                if(!SDFileCreate(FILE_LOG)){
					UARTWrite(1, "ERRORE - Impossibile creare il file\n");
				}
			}  
			
			
			if(SDFreeSpace()>100){
                sprintf(debug, "Proca scrittura SD\r\n");
				if(!SDFileAppend(FILE_LOG, debug, strlen(debug))){
                  #ifdef SER_DEBUG
				    UARTWrite(1, "ERRORE - Scrittura su SD Card fallita\n");
                  #endif
				} else {
                  #ifdef SER_DEBUG
				    UARTWrite(1, "File scritto!\n");
                  #endif	
				}
				
			}
			
			
			
			  
            } else {
              #ifdef SER_DEBUG
				UARTWrite(1, "ERRORE - SD Card non inizializzata\n");
              #endif
			}
          }
        } else {          //SD fisicamente rimossa
          #ifdef SER_DEBUG
            if(sdToInit==0) UARTWrite(1, "SD rimossa o assente!\r\n"); 	
          #endif
          sdToInit = 1;
        }
		
	}
}
